Revit二次开发之元素的移动

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Autodesk.Revit.DB;
using Autodesk.Revit.UI;
using Autodesk.Revit.Attributes;
using Autodesk.Revit.UI.Selection;
namespace ClassLibrary1
{
    [Autodesk.Revit.Attributes.Transaction(TransactionMode.Manual)]
    [Autodesk.Revit.Attributes.Regeneration(RegenerationOption.Manual)]
    public class GetElement : IExternalCommand
    {
        public Result Execute(ExternalCommandData commandData, ref string message, ElementSet elements)
        {
            UIDocument uidoc = commandData.Application.ActiveUIDocument;
            Document doc = uidoc.Document;
            Selection selection = uidoc.Selection;

            #region 元素的移动
            using (Transaction ts = new Transaction(doc))
            {
                ts.Start("Move Element");
                Reference reff = selection.PickObject(ObjectType.Element, " 选择一个墙体!");
                Element elem = doc.GetElement(reff);
                Wall wall = elem as Wall;

                //get location curve
                LocationCurve lc = wall.Location as LocationCurve;
                XYZ p1 = new XYZ(100, 100, 0);
                XYZ p2 = new XYZ(100, 0, 0);
                Line newWall = Line.CreateBound(p1, p2);
                //把墙的位置线换成新的线
                lc.Curve = newWall;
                ts.Commit();
                
            }


                #endregion

                return Result.Succeeded;
        }
    }
}

 

  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值